<?php
namespace Geral\Repositories;

class Estruturam extends \Doctrine\ORM\EntityRepository
{
    public static $estruturasInferiores;

    public static function buscaNomeEstrutGerencial($nrEstrutGerencial, $tipoEstrutGerencial, $dtCompetencia, $nrOrgTrab){
        $sql = "SELECT ESTRUTURAH.NMESTRUTURAH AS NMESTRUTGERENCIAL
                  FROM ESTRUTURAM
            INNER JOIN ESTRUTURAH
                    ON ESTRUTURAH.NRESTRUTURAM = ESTRUTURAM.NRESTRUTURAM
                   AND ESTRUTURAH.NRORG = ESTRUTURAM.NRORG
            INNER JOIN (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC, NRORG, NRESTRUTURAM
                          FROM ESTRUTURAH
                         WHERE ESTRUTURAH.DTMESCOMPETENC <= :DTCOMPETENCIA
                      GROUP BY NRORG, NRESTRUTURAM ) EHATUAL
                    ON EHATUAL.DTMESCOMPETENC = ESTRUTURAH.DTMESCOMPETENC
                   AND EHATUAL.NRORG = ESTRUTURAH.NRORG
                   AND EHATUAL.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
       LEFT OUTER JOIN TIPOESTRUTURA
                    ON TIPOESTRUTURA.NRTIPOESTRUTURA = ESTRUTURAM.NRTIPOESTRUTURA
                 WHERE ESTRUTURAM.NRTIPOESTRUTURA = :TIPOESTRUTGER
                   AND ESTRUTURAM.NRORG = :NRORGTRABALHO
                   AND ESTRUTURAM.NRESTRUTURAM = :NRESTRUTGEREN
              ORDER BY ESTRUTURAH.NMESTRUTURAH";

        $params = array("TIPOESTRUTGER" => $tipoEstrutGerencial,
                        "DTCOMPETENCIA" => $dtCompetencia,
                        "NRORGTRABALHO" => $nrOrgTrab,
                        "NRESTRUTGEREN" => $nrEstrutGerencial);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch (\Exception $ex) {
            throw $ex;
        }
    }

    public function maxNrestruturam()
    {
        $sqlMax = "SELECT MAX(NRESTRUTURAM)+1 FROM ESTRUTURAM";
        $result = $this->getEntityManager()->getConnection()->fetchColumn($sqlMax);
        return ($result) ? $result : false;
    }

    public static function getTipo1Rais($ano, $nrorg, $estruturas)
    {
        //CRIA A CLÁUSULA WHERE
        $where = "NRORG = $nrorg";
        if($estruturas){
            $where.= " AND NRESTRUTURAM IN ($estruturas)";
        }

        //ADICIONA A CLÁUSULA WHERE NO SQL
        $sql = <<<SQL
               SELECT  CNPJ,
                    '00'                      AS PREFIXO,
                    1                         AS TIPO_REGISTRO,
                    RAZAO_SOCIAL,
                    LOGRADOURO,
                    NUMERO,
                    COMPLEMENTO,
                    BAIRRO,
                    CEP,
                    CODIGO_MUNICIPIO,
                    MUNICIPIO,
                    SIGLA_ESTADO,
                    DDD,
                    TELEFONE,
                    EMAIL,
                    CNAE,
                    NATUREZA_JURIDICA,
                    NULL                      AS NUMERO_PROPRIETARIOS,
                    DATA_BASE,
                    TIPO_RAIS,
                    '00'                      AS ZEROS,
                    NULL                      AS CEI,
                    $ano                      AS ANO,
                    PORTE_EMPRESA,
                    OPT_SIMPLES,
                    PAT,
                    MAIS_5_SALARIOS,
                    MENOS_5_SALARIOS,
                    SERVICO_PROPRIO,
                    ADMINISTRACAO_COZINHA,
                    REFEICAO_CONVENIO,
                    REFEICAO_TRANSPORTADA,
                    CESTA_ALIMENTO,
                    ALIMENTACAO_CONVENIO,
                    ENCERROU_ATIVIDADE,
                    DATA_ENCERRAMENTO,
                    NULL                      AS ASSOCIATIVA_PATRONAL,
                    NULL                      AS VALOR_ASSOCIATIVA_PATRONAL,
                    NULL                      AS SINDICATO_PATRONAL,
                    NULL                      AS VALOR_SINDICATO_PATRONAL,
                    NULL                      AS ASSISTENCIAL_PATRONAL,
                    NULL                      AS VALOR_ASSISTENCIAL_PATRONAL,
                    NULL                      AS CONFEDERATIVA_PATRONAL,
                    NULL                      AS VALOR_CONFEDERATIVA_PATRONAL,
                    ATIVIDADE_ANO_BASE,
                    1                         AS CENTRALIZACAO_PAG_SINDICAL,
                    NULL                      AS CENTRALIZADORA,
                    1                         AS EMPRESA_FILIADA,
                    '02'                      AS TIPO_CONTROLE_PONTO,
                    NULL                      AS ESPACOS,
                    NULL                      AS EXCLUSIVO_EMPRESA,
                    NRESTRUTURAM,
                    NRORG
                FROM(
                    SELECT
                        ESTRUTURAH.CDCNPJESTRUT                                     AS CNPJ,                                --14
                        ESTRUTURAH.NMRAZSOCESTRUT                                   AS RAZAO_SOCIAL,                        --52
                        ENDERECOPARC.DSENDERECO                                     AS LOGRADOURO,                          --40
                        ENDERECOPARC.NRIMOVELENDERECO                               AS NUMERO,                              --06
                        ENDERECOPARC.DSCOMPLEENDERECO                               AS COMPLEMENTO,                         --21
                        ENDERECOPARC.NMBAIRROENDERECO                               AS BAIRRO,                              --19
                        ENDERECOPARC.NRCEPENDERECO                                  AS CEP,                                 --08
                        MUNICIPIO.CDMUNICIBGE                                       AS CODIGO_MUNICIPIO,                    --07
                        MUNICIPIO.NMMUNICIPIO                                       AS MUNICIPIO,                           --30
                        ENDERECOPARC.SGESTADO                                       AS SIGLA_ESTADO,                        --02
                        COMUNICAPARC_TELEFONE.CDPREFIXCOMUPARC                      AS DDD,                                 --02
                        COMUNICAPARC_TELEFONE.CDCOMUNICAPARC                        AS TELEFONE,                            --09
                        COMUNICAPARC_EMAIL.CDCOMUNICAPARC                           AS EMAIL,                               --45
                        ESTRUTURAH.CDCNAE                                           AS CNAE,                                --07
                        ESTRUTURAH.CDNATUJURI                                       AS NATUREZA_JURIDICA,                   --04
                        ESTRUTURAH.DTBASESINDICAL                                   AS DATA_BASE,                           --02
                        (CASE ESTRUTURAH.IDTIPOEMPR
                            WHEN '1'
                                THEN 1
                            WHEN '2'
                                THEN 2
                            ELSE 3
                        END)                                                        AS TIPO_INSCRICAO,                      --01
                        (CASE
                            WHEN QUANT_ESTRUTURA.NRESTRUTLEGAL IS NULL
                                THEN '1'
                            ELSE '0'
                        END)                                                        AS TIPO_RAIS,                           --01
                        '00'                                                        AS ZEROS,                               --02 FIXO
                        NULL                                                        AS CEI,                                 --12
                        $ano                                                        AS ANO,                                 --04 FIXO
                        ESTRUTURAM.NRTIPOESTRUTURA                                  AS PORTE_EMPRESA,                       --01
                        (CASE ESTRUTURAH.IDOPTSIMPLES
                            WHEN 'S'
                                THEN 1
                            ELSE 2
                        END)                                                        AS OPT_SIMPLES,                         --01
                        (CASE ESTRUTURAH.IDPARTICIPAT
                            WHEN 'S'
                                THEN 1
                            ELSE 2
                        END)                                                        AS PAT,                                 --01
                        MAIOR.QTD                                                   AS MAIS_5_SALARIOS,                     --06
                        MENOR.QTD                                                   AS MENOS_5_SALARIOS,                    --06
                        ROUND((EMPRESA.QUANT/QUANT_ESTRUTURA.QUANT)*100)            AS SERVICO_PROPRIO,                     --03
                        ROUND((TERCEIRIZADA.QUANT/QUANT_ESTRUTURA.QUANT)*100)       AS ADMINISTRACAO_COZINHA,               --03
                        ROUND((VALE_REFEICAO.QUANT/QUANT_ESTRUTURA.QUANT)*100)      AS REFEICAO_CONVENIO,                   --03
                        ROUND((REFEICAO_ENTREGUE.QUANT/QUANT_ESTRUTURA.QUANT)*100)  AS REFEICAO_TRANSPORTADA,               --03
                        ROUND((CESTA.QUANT/QUANT_ESTRUTURA.QUANT)*100)              AS CESTA_ALIMENTO,                      --03
                        ROUND((VALE_ALIMENTACAO.QUANT/QUANT_ESTRUTURA.QUANT)*100)   AS ALIMENTACAO_CONVENIO,                --03
                        (CASE
                            WHEN ESTRUTURAH.DTEXTINCAO IS NULL
                              THEN 2
                            ELSE 1
                          END)                                                      AS ENCERROU_ATIVIDADE,                  --01
                        ESTRUTURAH.DTEXTINCAO                                       AS DATA_ENCERRAMENTO,                   --08
                        (CASE
                            WHEN ESTRUTURAH.DTEXTINCAO IS NULL
                                THEN 1
                            WHEN TO_CHAR(ESTRUTURAH.DTEXTINCAO, 'YYYY')>=$ano
                                THEN 1
                            ELSE 2
                        END)                                                        AS ATIVIDADE_ANO_BASE,                  --01

                        --CAMPOS UTILIZADOS PARA FILTROS
                        ESTRUTURAM.NRESTRUTURAM,
                        ESTRUTURAM.NRORG


                    -- ESTRUTURAS QUE SERÃO BUSCADAS
                    FROM ESTRUTURAM

                    --HISTÓRICO DE MODIFICAÇÕES DA ESTRUTURA
                    INNER JOIN ESTRUTURAH
                        ON ESTRUTURAH.NRESTRUTURAM = ESTRUTURAM.NRESTRUTURAM
                        AND ESTRUTURAH.NRORG = ESTRUTURAM.NRORG

                    --FILTRO PELA ÚLTIMA MODIFICAÇÃO DA ESTRUTURA
                    INNER JOIN (SELECT
                                    MAX(DTMESCOMPETENC) AS DTMESCOMPETENC,
                                    ESTRUTURAH.NRESTRUTURAM,
                                    ESTRUTURAH.NRORG
                                FROM ESTRUTURAH
                                INNER JOIN GPE_MOVIMENTACAO
                                    ON ESTRUTURAH.NRESTRUTURAM = GPE_MOVIMENTACAO.NRESTRUTURAM
                                    AND ESTRUTURAH.NRORG = GPE_MOVIMENTACAO.NRORG
                                GROUP BY ESTRUTURAH.NRESTRUTURAM,
                                    ESTRUTURAH.NRORG)MAX_ESTRUTURAH
                        ON MAX_ESTRUTURAH.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
                        AND MAX_ESTRUTURAH.NRORG = ESTRUTURAH.NRORG
                        AND MAX_ESTRUTURAH.DTMESCOMPETENC = ESTRUTURAH.DTMESCOMPETENC

                    --BUSCA PELO ENDEREÇO PRINCIPAL DA ESTRUTURA
                    LEFT JOIN ENDERECOPARC
                        ON ENDERECOPARC.NRPARCNEGOCIO = ESTRUTURAM.NRPARCNEGOCIO
                        AND ENDERECOPARC.NRORG = ESTRUTURAM.NRORG

                    --BUSCA PELOS DADOS DO MUNICIPIO ONDE SE ENCONTRA A ESTRUTURA
                    LEFT JOIN MUNICIPIO
                        ON MUNICIPIO.CDMUNICIPIO = ENDERECOPARC.CDMUNICIPIO
                        AND MUNICIPIO.SGESTADO = ENDERECOPARC.SGESTADO
                        AND MUNICIPIO.CDPAIS = ENDERECOPARC.CDPAIS

                    --BUSCA POR FUNCIONÁRIOS QUE RECEBEM ACIMA DE 5 SALÁRIOS MÍNIMOS
                    LEFT JOIN (
                        SELECT COUNT(NRVINCULOM) QTD,
                            GPE_VINCULO.NRORG,
                            GPE_VINCULO.NRESTRUTLEGAL
                        FROM (
                            SELECT GPE_VINCULOM.NRVINCULOM,
                                GPE_VINCULOM.NMVINCULOM,
                                GPE_VINCULOH.NRESTRUTLEGAL,
                                GPE_ALTESALARIO.DTALTESALARIO,
                                GPE_ALTESALARIO.VRSALARIO,
                                GPE_ALTESALARIO.NRORG
                            FROM GPE_VINCULOM
                            INNER JOIN GPE_VINCULOH
                                ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                            INNER JOIN GPE_ALTESALARIO
                                ON GPE_VINCULOM.NRORG = GPE_ALTESALARIO.NRORG
                                AND GPE_VINCULOM.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                            WHERE GPE_VINCULOM.NRTIPOVINCULOM IN (1, 7, 9)
                                AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL
                                    OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                   FROM GPE_VINCULOH MAX_VINCULOH
                                                                   WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG
                                                                      AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                      AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                AND GPE_ALTESALARIO.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO) DTALTESALARIO
                                                                      FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                                                      WHERE MAX_ALTESALARIO.NRORG = GPE_ALTESALARIO.NRORG
                                                                          AND MAX_ALTESALARIO.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                                                                          AND MAX_ALTESALARIO.DTALTESALARIO <= '31/12/$ano')
                          )GPE_VINCULO
                        WHERE VRSALARIO > ( SELECT VRREFERENCIA*5 VRREFERENCIA
                                            FROM FPA_VALORREFERENCIAH
                                            WHERE NRVALORREFERENCIAM = 1
                                                AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                    FROM FPA_VALORREFERENCIAH
                                                                    WHERE DTMESCOMPETENC <= '31/12/$ano'))
                        GROUP BY GPE_VINCULO.NRORG,
                            GPE_VINCULO.NRESTRUTLEGAL
                    ) MAIOR
                        ON MAIOR.NRORG = ESTRUTURAH.NRORG
                        AND MAIOR.NRESTRUTLEGAL = ESTRUTURAM.NRESTRUTURAM

                    --BUSCA POR FUNCIONÁRIOS QUE RECEBEM ABAIXO DE 5 SALÁRIOS MÍNIMOS
                    LEFT JOIN (
                                SELECT COUNT(NRVINCULOM) QTD,
                                    GPE_VINCULO.NRORG,
                                    GPE_VINCULO.NRESTRUTLEGAL
                                FROM (
                                    SELECT GPE_VINCULOM.NRVINCULOM,
                                        GPE_VINCULOM.NMVINCULOM,
                                        GPE_VINCULOH.NRESTRUTLEGAL,
                                        GPE_ALTESALARIO.DTALTESALARIO,
                                        GPE_ALTESALARIO.VRSALARIO,
                                        GPE_ALTESALARIO.NRORG
                                    FROM GPE_VINCULOM
                                    INNER JOIN GPE_VINCULOH
                                        ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                        AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                    INNER JOIN GPE_ALTESALARIO
                                        ON GPE_VINCULOM.NRORG = GPE_ALTESALARIO.NRORG
                                        AND GPE_VINCULOM.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                                    WHERE GPE_VINCULOM.NRTIPOVINCULOM IN (1, 7, 9)
                                        AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                        AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL
                                            OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                        AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                           FROM GPE_VINCULOH MAX_VINCULOH
                                                                           WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG
                                                                              AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                              AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                        AND GPE_ALTESALARIO.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO) DTALTESALARIO
                                                                              FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                                                              WHERE MAX_ALTESALARIO.NRORG = GPE_ALTESALARIO.NRORG
                                                                                  AND MAX_ALTESALARIO.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                                                                                  AND MAX_ALTESALARIO.DTALTESALARIO <= '31/12/$ano')
                                  )GPE_VINCULO
                                WHERE VRSALARIO < ( SELECT VRREFERENCIA*5 VRREFERENCIA
                                                    FROM FPA_VALORREFERENCIAH
                                                    WHERE NRVALORREFERENCIAM = 1
                                                        AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                            FROM FPA_VALORREFERENCIAH
                                                                            WHERE DTMESCOMPETENC <= '31/12/$ano'))
                                GROUP BY GPE_VINCULO.NRORG,
                                    GPE_VINCULO.NRESTRUTLEGAL
                    ) MENOR
                        ON MENOR.NRORG = ESTRUTURAH.NRORG
                        AND MENOR.NRESTRUTLEGAL = ESTRUTURAM.NRESTRUTURAM

                    --BUSCA PELO TELEFONE DE CONTATO DA ESTRUTURA
                    INNER JOIN COMUNICAPARC COMUNICAPARC_TELEFONE
                        ON COMUNICAPARC_TELEFONE.NRPARCNEGOCIO = ENDERECOPARC.NRPARCNEGOCIO
                        AND COMUNICAPARC_TELEFONE.NRORG = ENDERECOPARC.NRORG
                        AND COMUNICAPARC_TELEFONE.CDFORMACOMU = '01' 
                        AND COMUNICAPARC_TELEFONE.NRCOMUNICAPARC = (SELECT MAX(NRCOMUNICAPARC) NRCOMUNICAPARC
                                                                    FROM COMUNICAPARC 
                                                                    WHERE COMUNICAPARC.NRPARCNEGOCIO  = COMUNICAPARC_TELEFONE.NRPARCNEGOCIO
                                                                        AND COMUNICAPARC.CDFORMACOMU  = COMUNICAPARC_TELEFONE.CDFORMACOMU
                                                                        AND COMUNICAPARC.NRORG  = COMUNICAPARC_TELEFONE.NRORG)

                    --BUSCA PELO E-MAIL DE CONTATO DA ESTRUTURA
                    INNER JOIN COMUNICAPARC COMUNICAPARC_EMAIL
                        ON COMUNICAPARC_EMAIL.NRPARCNEGOCIO = ENDERECOPARC.NRPARCNEGOCIO
                        AND COMUNICAPARC_EMAIL.NRORG = ENDERECOPARC.NRORG
                        AND COMUNICAPARC_EMAIL.CDFORMACOMU = '05' 
                        AND COMUNICAPARC_EMAIL.NRCOMUNICAPARC = (SELECT MAX(NRCOMUNICAPARC) NRCOMUNICAPARC
                                                                FROM COMUNICAPARC 
                                                                WHERE COMUNICAPARC.NRPARCNEGOCIO  = COMUNICAPARC_EMAIL.NRPARCNEGOCIO
                                                                    AND COMUNICAPARC.CDFORMACOMU  = COMUNICAPARC_EMAIL.CDFORMACOMU
                                                                    AND COMUNICAPARC.NRORG  = COMUNICAPARC_EMAIL.NRORG)

                    -- CONTA QUANTOS VÍNCULOS A EMPRESA POSSUI NO QUADRO DE FUNCIONÁRIOS
                    LEFT JOIN ( SELECT COUNT(DISTINCT(GPE_VINCULOH.NRVINCULOM))QUANT,
                                    GPE_VINCULOH.NRESTRUTLEGAL,
                                    GPE_VINCULOH.NRORG
                                FROM GPE_VINCULOM
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                WHERE GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                                    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                                        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                                    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                                     FROM GPE_VINCULOH MAX_VINCULOH
                                                                                     WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                                        AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                                        AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                                ) QUANT_ESTRUTURA
                        ON QUANT_ESTRUTURA.NRORG = ESTRUTURAM.NRORG
                        AND QUANT_ESTRUTURA.NRESTRUTLEGAL = ESTRUTURAM.NRESTRUTURAM

                    -- CONTA QUANTOS FUNCIONÁRIOS RECEBEM ALIMENTAÇÃO DENTRO DA EMPRESA
                    LEFT JOIN (SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT,
                                  GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                              FROM GPE_PATVINCULO
                              INNER JOIN GPE_VINCULOM
                                  ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
                                  AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
                              INNER JOIN GPE_VINCULOH
                                  ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                  AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                              WHERE GPE_PATVINCULO.NRTIPOSERVPAT = 1
                                AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                    OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                 FROM GPE_VINCULOH MAX_VINCULOH
                                                                 WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                    AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                    AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                              GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                        )EMPRESA
                        ON EMPRESA.NRORG = QUANT_ESTRUTURA.NRORG
                        AND EMPRESA.NRESTRUTLEGAL = QUANT_ESTRUTURA.NRESTRUTLEGAL

                    -- CONTA QUANTOS FUNCIONÁRIOS RECEBEM ALIMENTAÇÃO DE UMA TERCEIRIZADA DENTRO DA EMPRESA
                    LEFT JOIN ( SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT,
                                    GPE_VINCULOH.NRESTRUTLEGAL,
                                    GPE_VINCULOH.NRORG
                                FROM GPE_PATVINCULO
                                INNER JOIN GPE_VINCULOM
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                WHERE GPE_PATVINCULO.NRTIPOSERVPAT = 2
                                    AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                     FROM GPE_VINCULOH MAX_VINCULOH
                                                                     WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                        )TERCEIRIZADA
                        ON TERCEIRIZADA.NRORG = QUANT_ESTRUTURA.NRORG
                        AND TERCEIRIZADA.NRESTRUTLEGAL = QUANT_ESTRUTURA.NRESTRUTLEGAL

                    -- CONTA QUANTOS FUNCIONÁRIOS RECEBEM VALE REFEIÇÃO
                    LEFT JOIN ( SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT,
                                    GPE_VINCULOH.NRESTRUTLEGAL,
                                    GPE_VINCULOH.NRORG
                                FROM GPE_PATVINCULO
                                INNER JOIN GPE_VINCULOM
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                WHERE GPE_PATVINCULO.NRTIPOSERVPAT = 2
                                    AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                     FROM GPE_VINCULOH MAX_VINCULOH
                                                                     WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                        )VALE_REFEICAO
                        ON VALE_REFEICAO.NRORG = QUANT_ESTRUTURA.NRORG
                        AND VALE_REFEICAO.NRESTRUTLEGAL = QUANT_ESTRUTURA.NRESTRUTLEGAL

                    -- CONTA QUANTOS FUNCIONÁRIOS RECEBEM REFEIÇÕES ENTREGUES NA EMPRESA (MARMITA)
                    LEFT JOIN ( SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT,
                                    GPE_VINCULOH.NRESTRUTLEGAL,
                                    GPE_VINCULOH.NRORG
                                FROM GPE_PATVINCULO
                                INNER JOIN GPE_VINCULOM
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                WHERE GPE_PATVINCULO.NRTIPOSERVPAT = 2
                                    AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                     FROM GPE_VINCULOH MAX_VINCULOH
                                                                     WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                        )REFEICAO_ENTREGUE
                        ON REFEICAO_ENTREGUE.NRORG = QUANT_ESTRUTURA.NRORG
                        AND REFEICAO_ENTREGUE.NRESTRUTLEGAL = QUANT_ESTRUTURA.NRESTRUTLEGAL

                    -- CONTA QUANTOS FUNCIONÁRIOS RECEBEM CESTA BÁSICA
                    LEFT JOIN (SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT,
                                    GPE_VINCULOH.NRESTRUTLEGAL,
                                    GPE_VINCULOH.NRORG
                                FROM GPE_PATVINCULO
                                INNER JOIN GPE_VINCULOM
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                WHERE GPE_PATVINCULO.NRTIPOSERVPAT = 2
                                    AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                     FROM GPE_VINCULOH MAX_VINCULOH
                                                                     WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                        AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                        )CESTA
                        ON CESTA.NRORG = QUANT_ESTRUTURA.NRORG
                        AND CESTA.NRESTRUTLEGAL = QUANT_ESTRUTURA.NRESTRUTLEGAL

                    -- CONTA QUANTOS FUNCIONÁRIOS RECEBEM VALE ALIMENTAÇÃO
                    LEFT JOIN ( SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT,
                                    GPE_VINCULOH.NRESTRUTLEGAL,
                                    GPE_VINCULOH.NRORG
                                FROM GPE_PATVINCULO
                                INNER JOIN GPE_VINCULOM
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                                WHERE GPE_PATVINCULO.NRTIPOSERVPAT = 2
                                    AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
                                    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                                        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
                                    AND GPE_VINCULOH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                                                        FROM GPE_VINCULOH MAX_VINCULOH
                                                                        WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                            AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                            AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
                                GROUP BY GPE_VINCULOH.NRESTRUTLEGAL,
                                  GPE_VINCULOH.NRORG
                        )VALE_ALIMENTACAO
                        ON VALE_ALIMENTACAO.NRORG = QUANT_ESTRUTURA.NRORG
                        AND VALE_ALIMENTACAO.NRESTRUTLEGAL = QUANT_ESTRUTURA.NRESTRUTLEGAL
                )ESTRUTURAH
                WHERE $where
SQL;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        if($result){
            $qnt = count($result);
            for($c=0; $c<$qnt; $c++){
                if(!empty($result[$c]['CNPJ'])){
                    $result[$c]['TIPO_INSCRICAO'] = 1;
                }else{
                    $result[$c]['TIPO_INSCRICAO'] = 3;
                }
            }
        }else{
            $result = false;
        }

        return ($result);
    }

    public static function getEstruturaSuperior($nrorg, $nrestruturam, $hierarquia, $dtmescompetencia )
    {
        $sql = <<<SQL
            SELECT NRESTRUTURAMREL
            FROM (SELECT *
                    FROM HIERARQUIAORG
                   WHERE /*( NRESTRUTURAMREL <> NRESTRUTURAMSUP OR NRESTRUTURAMSUP IS NULL )
                     AND */NRORG = :P_NRORG
                     AND DTINIVIGENCIA <= :P_COMPETENCIA
                     AND HIERARQUIAORG.NRTIPOHIERARQORG = :P_HIERARQUIA
                 )
            START WITH NRESTRUTURAMREL = :P_ESTRUTURA
            CONNECT BY PRIOR NRESTRUTURAMREL = NRESTRUTURAMSUP
SQL;
        $params = array(
            'P_NRORG' => $nrorg,
            'P_COMPETENCIA' => $dtmescompetencia,
            'P_HIERARQUIA' => $hierarquia,
            'P_ESTRUTURA' => $nrestruturam
        );

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql, $params);
        return ($result) ? $result : false;

    }

    private static function getEstrutInferior($nrorg, $estruturas, $hierarquia, $dtmescompetencia)
    {
        $estrut = array();

        foreach($estruturas as $estrutura){
            $estrut[] = $estrutura['NRESTRUTURAMREL'];
        }

        foreach($estrut as $estrutura){
            self::$estruturasInferiores[] = $estrutura;
        }

        $superior = implode(' ,', $estrut);
        if($superior){
            $sql = "SELECT NRESTRUTURAMREL
                    FROM HIERARQUIAORG
                    WHERE NRESTRUTURAMSUP IN ($superior)
                        AND NRORG = $nrorg
                        AND NRTIPOHIERARQORG = $hierarquia";

            $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
            if($result){
                self::getEstruturaInferior($nrorg, $result, $hierarquia, $dtmescompetencia);
            }
            return self::$estruturasInferiores;
        }

    }

    public static function getEstruturaInferior($nrorg, $estruturas, $hierarquia, $dtmescompetencia)
    {
        self::$estruturasInferiores = array();
        return (self::getEstrutInferior($nrorg, $estruturas, $hierarquia, $dtmescompetencia));
    }

    public static function getInformacaoResponsavel($nrorg, $estrutura, $ano)
    {
        $sql = <<<SQL
SELECT ESTRUTURAH.CDCNPJESTRUT AS CNPJ,
    ESTRUTURAH.CDCEIESTRUT AS CEI,
    ESTRUTURAH.NMRAZSOCESTRUT AS RAZAO_SOCIAL,
    ENDERECOPARC.DSENDERECO AS LOGRADOURO,
    ENDERECOPARC.NRIMOVELENDERECO AS NUMERO,
    ENDERECOPARC.DSCOMPLEENDERECO AS COMPLEMENTO,
    ENDERECOPARC.NMBAIRROENDERECO AS BAIRRO,
    ENDERECOPARC.NRCEPENDERECO AS CEP,
    MUNICIPIO.CDMUNICIBGE AS CDMUNICIPIO,
    MUNICIPIO.NMMUNICIPIO AS NMMUNCIPIO,
    ENDERECOPARC.SGESTADO AS ESTADO,
    COMUNICAPARC.CDPREFIXCOMUPARC AS DDD,
    COMUNICAPARC.CDCOMUNICAPARC AS TELEFONE,
    MAX(COMUNICAPARC.NRCOMUNICAPARC) NRCOMUNICAPARC


FROM ESTRUTURAM

INNER JOIN ESTRUTURAH
    ON ESTRUTURAM.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
    AND ESTRUTURAM.NRORG = ESTRUTURAH.NRORG
    AND ESTRUTURAH.DTMESCOMPETENC = (   SELECT MAX(MAX_ESTRUTURAH.DTMESCOMPETENC) DTMESCOMPETENC
                                        FROM ESTRUTURAH MAX_ESTRUTURAH
                                        WHERE MAX_ESTRUTURAH.DTMESCOMPETENC <= '31/12/$ano'
                                            AND MAX_ESTRUTURAH.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
                                            AND MAX_ESTRUTURAH.NRORG = ESTRUTURAH.NRORG)

LEFT JOIN PARCNEGOCIO
    ON PARCNEGOCIO.NRPARCNEGOCIO = ESTRUTURAM.NRPARCNEGOCIO
    AND PARCNEGOCIO.NRORG = ESTRUTURAM.NRORG

LEFT JOIN ENDERECOPARC
    ON PARCNEGOCIO.NRPARCNEGOCIO = ENDERECOPARC.NRPARCNEGOCIO
    AND PARCNEGOCIO.NRORG = ENDERECOPARC.NRORG

LEFT JOIN COMUNICAPARC
    ON COMUNICAPARC.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
    AND COMUNICAPARC.NRORG = PARCNEGOCIO.NRORG
    AND COMUNICAPARC.CDFORMACOMU = '01'

LEFT JOIN MUNICIPIO
    ON MUNICIPIO.CDMUNICIPIO = ENDERECOPARC.CDMUNICIPIO
    AND MUNICIPIO.SGESTADO = ENDERECOPARC.SGESTADO
    AND MUNICIPIO.CDPAIS = ENDERECOPARC.CDPAIS

WHERE ESTRUTURAM.NRESTRUTURAM = $estrutura
    AND ESTRUTURAM.NRORG = $nrorg

GROUP BY ESTRUTURAH.CDCNPJESTRUT,
    ESTRUTURAH.CDCEIESTRUT,
    ESTRUTURAH.NMRAZSOCESTRUT,
    ENDERECOPARC.DSENDERECO,
    ENDERECOPARC.NRIMOVELENDERECO,
    ENDERECOPARC.DSCOMPLEENDERECO,
    ENDERECOPARC.NMBAIRROENDERECO,
    ENDERECOPARC.NRCEPENDERECO,
    MUNICIPIO.CDMUNICIBGE,
    MUNICIPIO.NMMUNICIPIO,
    ENDERECOPARC.SGESTADO,
    COMUNICAPARC.CDPREFIXCOMUPARC,
    COMUNICAPARC.CDCOMUNICAPARC
SQL;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
        return ($result)?$result:NULL;

    }

    public static function getPreInformacao($ano, $nrorg, $estruturas = array())
    {
        if(is_array($estruturas))
            $estruturas = implode(', ',$estruturas);

        $sql = <<<SQL
SELECT *
FROM (
    SELECT
        ESTRUTURAH.CDCNPJESTRUT,
        ESTRUTURAH.CDCEIESTRUT,
        ESTRUTURAH.NMRAZSOCESTRUT,
        ESTRUTURAH.CDNATUJURI,
        ESTRUTURAH.CDCNAE,
        ESTRUTURAH.IDOPTSIMPLES,
        ESTRUTURAH.IDPARTICIPAT,
        ESTRUTURAH.NRPARCNEGOCIO,
        ESTRUTURAH.DTBASESINDICAL,
        ENDERECOPARC.CDPAIS,
        ENDERECOPARC.SGESTADO,
        ENDERECOPARC.CDMUNICIPIO,
        ENDERECOPARC.NMBAIRROENDERECO,
        ENDERECOPARC.NRCEPENDERECO,
        ENDERECOPARC.DSENDERECO,
        ENDERECOPARC.NRIMOVELENDERECO,
        TELEFONE.CDPREFIXCOMUPARC AS DDD,
        TELEFONE.CDCOMUNICAPARC AS TELEFONE,
        EMAIL.CDCOMUNICAPARC AS EMAIL,
        ESTRUTURAM.NRTIPOESTRUTURA,
        ESTRUTURAM.NRORG,
        ESTRUTURAH.DTMESCOMPETENC,
        ESTRUTURAM.NRESTRUTURAM

    FROM ESTRUTURAM
    INNER JOIN ESTRUTURAH
        ON ESTRUTURAM.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
        AND ESTRUTURAM.NRORG = ESTRUTURAH.NRORG
    INNER JOIN (
            SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC,
                NRORG,
                NRESTRUTURAM
            FROM ESTRUTURAH
            WHERE DTMESCOMPETENC <= '31/12/$ano'
            AND (DTEXTINCAO IS NULL OR DTEXTINCAO BETWEEN '01/01/$ano' AND '31/12/$ano')
            GROUP BY NRORG,
                NRESTRUTURAM
        )MAX_ESTRUTURAH
        ON ESTRUTURAH.NRESTRUTURAM = MAX_ESTRUTURAH.NRESTRUTURAM
        AND ESTRUTURAH.NRORG = MAX_ESTRUTURAH.NRORG
        AND ESTRUTURAH.DTMESCOMPETENC = MAX_ESTRUTURAH.DTMESCOMPETENC

    LEFT JOIN ENDERECOPARC
        ON ESTRUTURAH.NRPARCNEGOCIO = ENDERECOPARC.NRPARCNEGOCIO
        AND ESTRUTURAH.NRORG = ENDERECOPARC.NRORG
        AND ENDERECOPARC.CDTIPOENDERECO = 'PRINCIPAL'

    LEFT JOIN COMUNICAPARC TELEFONE
        ON ESTRUTURAH.NRPARCNEGOCIO = TELEFONE.NRPARCNEGOCIO
        AND ESTRUTURAH.NRORG = TELEFONE.NRORG
        AND TELEFONE.CDFORMACOMU = '01'

    LEFT JOIN COMUNICAPARC EMAIL
        ON ESTRUTURAH.NRPARCNEGOCIO = EMAIL.NRPARCNEGOCIO
        AND ESTRUTURAH.NRORG = EMAIL.NRORG
        AND EMAIL.CDFORMACOMU = '05'

    INNER JOIN GPE_PARAMORG
        ON GPE_PARAMORG.NRORG = ESTRUTURAM.NRORG
        AND GPE_PARAMORG.NRTPESTRUTLEGAL = ESTRUTURAM.NRTIPOESTRUTURA
)VERIFICA_01
WHERE NRORG = $nrorg
    AND NRESTRUTURAM IN ($estruturas)
SQL;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
        return ($result)?$result:false;

    }

    public static function getInfoMatriz($nrorg, $nrestruturam, $ano)
    {
        $sql = <<<SQL
SELECT ESTRUTURAM.NRESTRUTURAM,
    ESTRUTURAH.CDCNPJESTRUT
    FROM ESTRUTURAM
        INNER JOIN ESTRUTURAH
            ON ESTRUTURAM.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
            AND ESTRUTURAM.NRORG = ESTRUTURAH.NRORG
            AND ESTRUTURAH.DTMESCOMPETENC = ( SELECT (MAX_ESTRUTURAH.DTMESCOMPETENC) DTMESCOMPETENC
                                              FROM ESTRUTURAH MAX_ESTRUTURAH
                                              WHERE MAX_ESTRUTURAH.NRORG = ESTRUTURAH.NRORG
                                              AND MAX_ESTRUTURAH.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
                                              AND MAX_ESTRUTURAH.DTMESCOMPETENC <= '31/12/$ano')
    WHERE ESTRUTURAH.NRORG = $nrorg
        AND ESTRUTURAM.NRESTRUTURAM = $nrestruturam
SQL;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
        return ($result)?$result:false;
    }

    /**
     * Busca quantidade de vínculos que recebem acima de 5 salários mínimos
     *
     * @param int $nrestruturam
     * @param int $nrorg
     * @param int $ano
     * @return array
     */
    public static function getVincSalAcima5SM( $nrestruturam, $nrorg, $ano)
    {
        $sql = <<<SQL
SELECT COUNT(NRVINCULOM) QTD,
    GPE_VINCULO.NRORG,
    GPE_VINCULO.NRESTRUTLEGAL
FROM (
    SELECT GPE_VINCULOM.NRVINCULOM,
        GPE_VINCULOM.NMVINCULOM,
        GPE_VINCULOH.NRESTRUTLEGAL,
        GPE_ALTESALARIO.DTALTESALARIO,
        GPE_ALTESALARIO.VRSALARIO,
        GPE_ALTESALARIO.NRORG
    FROM GPE_VINCULOM
    INNER JOIN GPE_VINCULOH
        ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
        AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
    INNER JOIN GPE_ALTESALARIO
        ON GPE_VINCULOM.NRORG = GPE_ALTESALARIO.NRORG
        AND GPE_VINCULOM.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
    WHERE GPE_VINCULOM.NRTIPOVINCULOM IN (1, 7, 9)
        AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
        AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL
            OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
        AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                           FROM GPE_VINCULOH MAX_VINCULOH
                                           WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG
                                              AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                              AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
        AND GPE_ALTESALARIO.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO) DTALTESALARIO
                                              FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                              WHERE MAX_ALTESALARIO.NRORG = GPE_ALTESALARIO.NRORG
                                                  AND MAX_ALTESALARIO.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                                                  AND MAX_ALTESALARIO.DTALTESALARIO <= '31/12/$ano')
  )GPE_VINCULO
WHERE NRESTRUTLEGAL = $nrestruturam
    AND NRORG = $nrorg
    AND VRSALARIO > ( SELECT VRREFERENCIA*5 VRREFERENCIA
                    FROM FPA_VALORREFERENCIAH
                    WHERE NRVALORREFERENCIAM = 1
                        AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                            FROM FPA_VALORREFERENCIAH MAX_VALORREFERENCIAH
                                            WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = MAX_VALORREFERENCIAH.NRVALORREFERENCIAM
                                                AND DTMESCOMPETENC <= '31/12/$ano'))
GROUP BY GPE_VINCULO.NRORG,
    GPE_VINCULO.NRESTRUTLEGAL
SQL;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
        return ($result)?$result[0]:false;
    }

    /**
     * Busca quantidade de vínculos que recebem abaixo de 5 salários mínimos
     *
     * @param int $nrestruturam
     * @param int $nrorg
     * @param int $ano
     * @return array
     */
    public static function getVincSalAbaixo5SM( $nrestruturam, $nrorg, $ano)
    {
        $sql = <<<SQL
SELECT COUNT(NRVINCULOM) QTD,
    GPE_VINCULO.NRORG,
    GPE_VINCULO.NRESTRUTLEGAL
FROM (
    SELECT GPE_VINCULOM.NRVINCULOM,
        GPE_VINCULOM.NMVINCULOM,
        GPE_VINCULOH.NRESTRUTLEGAL,
        GPE_ALTESALARIO.DTALTESALARIO,
        GPE_ALTESALARIO.VRSALARIO,
        GPE_ALTESALARIO.NRORG
    FROM GPE_VINCULOM
    INNER JOIN GPE_VINCULOH
        ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
        AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
    INNER JOIN GPE_ALTESALARIO
        ON GPE_VINCULOM.NRORG = GPE_ALTESALARIO.NRORG
        AND GPE_VINCULOM.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
    WHERE GPE_VINCULOM.NRTIPOVINCULOM IN (1, 7, 9)
        AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
        AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL
            OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
        AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                           FROM GPE_VINCULOH MAX_VINCULOH
                                           WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG
                                              AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                              AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
        AND GPE_ALTESALARIO.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO) DTALTESALARIO
                                              FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                              WHERE MAX_ALTESALARIO.NRORG = GPE_ALTESALARIO.NRORG
                                                  AND MAX_ALTESALARIO.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
                                                  AND MAX_ALTESALARIO.DTALTESALARIO <= '31/12/$ano')
  )GPE_VINCULO
WHERE NRESTRUTLEGAL = $nrestruturam
    AND NRORG = $nrorg
    AND VRSALARIO < ( SELECT VRREFERENCIA*5 VRREFERENCIA
                    FROM FPA_VALORREFERENCIAH
                    WHERE NRVALORREFERENCIAM = 1
                        AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                            FROM FPA_VALORREFERENCIAH MAX_VALORREFERENCIAH
                                            WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = MAX_VALORREFERENCIAH.NRVALORREFERENCIAM
                                                AND DTMESCOMPETENC <= '31/12/$ano'))
GROUP BY GPE_VINCULO.NRORG,
    GPE_VINCULO.NRESTRUTLEGAL
SQL;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
        return ($result)?$result[0]:false;
    }

    /**
     * Retorna a quantidade de funcionários por tipo de serviço da PAT
     *
     * @param $nrestruturam
     * @param $nrorg
     * @param $nrtiposervpat
     * @param $ano
     *
     * @return array
     * @throws \Exception
     */
    public static function quantFuncPorPat( $nrestruturam, $nrorg, $nrtiposervpat, $ano)
    {
        try {
            $sql = <<<SQL
SELECT COUNT(DISTINCT(GPE_PATVINCULO.NRVINCULOM)) QUANT
FROM GPE_PATVINCULO
INNER JOIN GPE_VINCULOM
    ON GPE_VINCULOM.NRVINCULOM = GPE_PATVINCULO.NRVINCULOM
    AND GPE_VINCULOM.NRORG = GPE_PATVINCULO.NRORG
INNER JOIN GPE_VINCULOH
    ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
    AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
WHERE GPE_PATVINCULO.NRTIPOSERVPAT = $nrtiposervpat
    AND GPE_VINCULOM.DTADMISSAOVINC <= '31/12/$ano'
    AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL
        OR GPE_VINCULOM.DTRESCISAOVINC >= '01/01/$ano')
    AND GPE_VINCULOH.NRESTRUTLEGAL = $nrestruturam
    AND GPE_VINCULOH.NRORG = $nrorg
    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                                     FROM GPE_VINCULOH MAX_VINCULOH
                                     WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                        AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                        AND MAX_VINCULOH.DTMESCOMPETENC <= '31/12/$ano')
SQL;
            $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
            return ($result)?$result['QUANT']:false;

        } catch (\Exception $e) {
            throw $e;
        }

    }

}