<?php
namespace Suprimentos\Logic\Compra {
    use Geral\Util\DateUtil;
    use Setforms2\Shared\Registry;
    use Suprimentos\Entities\Prodcompra;

    class RegistraProdcompra{

        //Insere Novo Item para Compra
        /**
         * @param $nrorg
         * @param $nrcompra
         * @param $cdfilisoli
         * @param $cdfillanca
         * @param $nrsolicmp
         * @param $cdproduto
         * @param $dtprogentr
         * @throws \Exception
         */
        public static function registraProdcompra($nrorg, $nrcompra, $cdfilisoli, $cdfillanca, $nrsolicmp, $cdproduto, $dtprogentr){
            try{
                $prodcompra = Prodcompra::findOneByNrorgAndNrcompraAndCdfilsoliAndCdfillanAndNrsolicmpAndCdprodutoAndDtprogentr($nrorg, $nrcompra, $cdfilisoli, $cdfillanca, $nrsolicmp, $cdproduto, DateUtil::getDataDeString($dtprogentr));
                if($prodcompra){
                    $prodcompra->setDtprogentr(DateUtil::truncateData(DateUtil::getDataDeString($dtprogentr)));
                }else{
                    $prodcompra = new Prodcompra();
                    $prodcompra->setNrorg($nrorg);
                    $prodcompra->setNrcompra($nrcompra);
                    $prodcompra->setCdfilsoli($cdfilisoli);
                    $prodcompra->setCdfillan($cdfillanca);
                    $prodcompra->setNrsolicmp($nrsolicmp);
                    $prodcompra->setCdproduto($cdproduto);
                    $prodcompra->setDtprogentr(DateUtil::truncateData(DateUtil::getDataDeString($dtprogentr)));
                }
                $prodcompra->persist();
                Registry::getEntityManager()->flush();
            }catch(\Exception $e){
                throw $e;
            }
        }

    }
}