CREATE TABLE PRODORIGSTMG
(
	CDEMPRESA           VARCHAR2(02)         NOT NULL,
	CDINSCESTA          VARCHAR2(16)         NOT NULL,
	IDENTRSAIDOP        VARCHAR2(1)          NOT NULL,
	CDTIPOOPER          VARCHAR2(02)         NOT NULL,
	CDPRODUTO           VARCHAR2(10)         NOT NULL,
	NRORG               NUMBER 	      	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO             VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO          DATE            DEFAULT SYSDATE,
    DTULTATU            DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO      VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU         NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU        VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT CKC_IDATIVO_PRODORIGSTMG CHECK (IDATIVO IN ('S','N')),
		CONSTRAINT PK_PRODORIGSTMG PRIMARY KEY (CDEMPRESA, CDINSCESTA, IDENTRSAIDOP, CDTIPOOPER, CDPRODUTO)
)
/

CREATE INDEX FIS00859_FK ON PRODORIGSTMG (CDEMPRESA ASC, CDINSCESTA ASC)
/  

ALTER TABLE PRODORIGSTMG
    ADD CONSTRAINT FKFIS00859PRODORIG FOREIGN KEY  (CDEMPRESA, CDINSCESTA)
       REFERENCES INSCRESTAD (CDEMPRESA, CDINSCESTA)
/

CREATE INDEX FIS00860_FK ON PRODORIGSTMG (IDENTRSAIDOP ASC, CDTIPOOPER ASC)
/  

ALTER TABLE PRODORIGSTMG
    ADD CONSTRAINT FKFIS00860TIPOOPER FOREIGN KEY  (IDENTRSAIDOP, CDTIPOOPER)
       REFERENCES TIPOOPERAC (IDENTRSAIDOP, CDTIPOOPER)
/

CREATE INDEX FIS00861_FK ON PRODORIGSTMG (CDPRODUTO ASC)
/  

ALTER TABLE PRODORIGSTMG
    ADD CONSTRAINT FKFIS00861TIPOOPER FOREIGN KEY  (CDPRODUTO)
       REFERENCES PRODUTO (CDPRODUTO)
/


ALTER TABLE PARAMESTSPED ADD CDAJCREDANTST VARCHAR2(10) NULL 
/

ALTER TABLE PARAMESTSPED ADD DSAJCREDANTST VARCHAR2(400) NULL
/